org.vertx.java.core.sockjs

## Interface SockJSServer

-     public interface SockJSServer

  This is an implementation of the server side part of SockJS

  SockJS enables browsers to communicate with the server using a simple WebSocket-like api for sending and receiving messages. Under the bonnet SockJS chooses to use one of several protocols depending on browser capabilities and what apppears to be working across the network.

  Available protocols include:

  - WebSockets
  - xhr-polling
  - xhr-streaming
  - json-polling
  - event-source
  - html-file

  This means, it should just work irrespective of what browser is being used, and whether there are nasty things like proxies and load balancers between the client and the server.

  For more detailed information on SockJS, see their website.

  On the server side, you interact using instances of `SockJSSocket` - this allows you to send data to the client or receive data via the `ReadStream.dataHandler(org.vertx.java.core.Handler<org.vertx.java.core.buffer.Buffer>)`.

  You can register multiple applications with the same SockJSServer, each using different path prefixes, each application will have its own handler, and configuration.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `bridge(JsonObject sjsConfig, JsonArray inboundPermitted, JsonArray outboundPermitted)` Install an app which bridges the SockJS server to the event bus
    `void` | `bridge(JsonObject sjsConfig, JsonArray inboundPermitted, JsonArray outboundPermitted, long authTimeout)` Install an app which bridges the SockJS server to the event bus
    `void` | `bridge(JsonObject sjsConfig, JsonArray inboundPermitted, JsonArray outboundPermitted, long authTimeout, java.lang.String authAddress)` Install an app which bridges the SockJS server to the event bus
    `void` | `installApp(JsonObject config, Handler<SockJSSocket> sockHandler)` Install an application

- - ### Method Detail

    - #### installApp

          void installApp(JsonObject config,
                        Handler<SockJSSocket> sockHandler)

      Install an application
      Parameters:
        `config` - The application configuration
        `sockHandler` - A handler that will be called when new SockJS sockets are created

    - #### bridge

          void bridge(JsonObject sjsConfig,
                    JsonArray inboundPermitted,
                    JsonArray outboundPermitted)

      Install an app which bridges the SockJS server to the event bus
      Parameters:
        `sjsConfig` - The config for the app
        `inboundPermitted` - A list of JSON objects which define permitted matches for inbound (client->server) traffic
        `outboundPermitted` - A list of JSON objects which define permitted matches for outbound (server->client) traffic

    - #### bridge

          void bridge(JsonObject sjsConfig,
                    JsonArray inboundPermitted,
                    JsonArray outboundPermitted,
                    long authTimeout)

      Install an app which bridges the SockJS server to the event bus
      Parameters:
        `sjsConfig` - The config for the app
        `inboundPermitted` - A list of JSON objects which define permitted matches for inbound (client->server) traffic
        `outboundPermitted` - A list of JSON objects which define permitted matches for outbound (server->client) traffic
        `authTimeout` - Default time an authorisation will be cached for in the bridge (defaults to 5 minutes)

    - #### bridge

          void bridge(JsonObject sjsConfig,
                    JsonArray inboundPermitted,
                    JsonArray outboundPermitted,
                    long authTimeout,
                    java.lang.String authAddress)

      Install an app which bridges the SockJS server to the event bus
      Parameters:
        `sjsConfig` - The config for the app
        `inboundPermitted` - A list of JSON objects which define permitted matches for inbound (client->server) traffic
        `outboundPermitted` - A list of JSON objects which define permitted matches for outbound (server->client) traffic
        `authTimeout` - Default time an authorisation will be cached for in the bridge (defaults to 5 minutes)
        `authAddress` - Address of auth manager. Defaults to 'vertx.basicauthmanager.authorise'